; Puncher v.2006-01-27 (init: v.2004-11-22)
; Usage: key F8 - select window, F6 - make hole under cursor, F5 - cancel all holes in selected window, Esc - exit.

.386
.model		flat,stdcall
option		casemap:none
  
include		\masm32\include\windows.inc
include		\masm32\include\user32.inc
include		\masm32\include\kernel32.inc
include 	\masm32\include\gdi32.inc
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\gdi32.lib

.data                   
about	db "Puncher by kero <geocities.com/xmemor> v.2006-01-27",0

.data?
hw		HWND ?
hr1		HRGN ?
hr2		HRGN ?
rt		RECT <>
pt		POINT <>

.code                
start:
		invoke CreateEllipticRgn,-8,-8,8,8
		mov hr1,eax
@@@:
		invoke Sleep,40
		invoke GetCursorPos,addr pt
		invoke GetKeyState,VK_F8								; F8 - fix hwnd
		test ax,8000h
		jz @f
		invoke WindowFromPoint,pt.x,pt.y
		mov hw,eax
		jmp @@@
@@:
		invoke GetKeyState,VK_F6								; F6 - make hole
		test ax,8000h
		jz @f
		invoke GetWindowRect,hw,addr rt
		mov eax,rt.left
		sub pt.x,eax
		mov eax,rt.top
		sub pt.y,eax
		invoke OffsetRgn,hr1,pt.x,pt.y
		invoke CreateRectRgn,0,0,0,0
		mov hr2,eax
		invoke GetWindowRgn,hw,hr2
		.if eax==ERRORAPI
			mov eax,rt.left
			sub rt.right,eax
			mov eax,rt.top
			sub rt.bottom,eax
			invoke SetRectRgn,hr2,0,0,rt.right,rt.bottom
		.endif
		invoke CombineRgn,hr2,hr2,hr1,RGN_DIFF
		invoke SetWindowRgn,hw,hr2,1
		xor eax,eax
		xor ecx,ecx
		sub eax,pt.x
		sub ecx,pt.y
		invoke OffsetRgn,hr1,eax,ecx
		invoke DeleteObject,hr2
		jmp @@@
@@:
		invoke GetKeyState,VK_F5								; F5 - cancel holes
		test ax,8000h
		jz @f
		invoke SetWindowRgn,hw,0,1
		jmp @@@
@@:
		invoke GetKeyState,VK_ESCAPE						; Esc - exit
		test ax,8000h
		jz @@@
		invoke DeleteObject,hr1
		invoke ExitProcess,0
end start
